## nnn 4.3

=== Makefile ===
VERSION = $(shell grep -m1 VERSION $(SRC) | cut -f 2 -d'"')

PREFIX ?= /usr/local
MANPREFIX ?= $(PREFIX)/share/man
DESKTOPPREFIX ?= $(PREFIX)/share/applications
DESKTOPICONPREFIX ?= $(PREFIX)/share/icons/hicolor
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install
CP ?= cp

CFLAGS_OPTIMIZATION ?= -O3

O_DEBUG := 0  # debug binary
O_NORL := 0  # no readline support
O_PCRE := 0  # link with PCRE library
O_NOLC := 0  # no locale support
O_NOMOUSE := 0  # no mouse support
O_NOBATCH := 0  # no built-in batch renamer
O_NOFIFO := 0  # no FIFO previewer support
O_CTX8 := 0  # enable 8 contexts
O_ICONS := 0  # support icons-in-terminal
O_NERD := 0  # support icons-nerdfont
O_QSORT := 0  # use Alexey Tourbin's QSORT implementation
O_BENCH := 0  # benchmark mode (stops at first user input)
O_NOSSN := 0  # disable session support
O_NOUG := 0  # disable user, group name in status bar
O_NOX11 := 0  # disable X11 integration
O_MATCHFLTR := 0  # allow filters without matches

# User patches
O_GITSTATUS := 0 # add git status to detail view
O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view
O_RESTOREPREVIEW := 0 # add preview pipe to close and restore preview pane

# convert targets to flags for backwards compatibility
ifneq ($(filter debug,$(MAKECMDGOALS)),)
	O_DEBUG := 1
endif
ifneq ($(filter norl,$(MAKECMDGOALS)),)
	O_NORL := 1
endif
ifneq ($(filter nolc,$(MAKECMDGOALS)),)
	O_NORL := 1
	O_NOLC := 1
endif

ifeq ($(strip $(O_DEBUG)),1)
	CPPFLAGS += -DDEBUG
	CFLAGS += -g
endif

ifeq ($(strip $(O_NORL)),1)
	CPPFLAGS += -DNORL
else ifeq ($(strip $(O_STATIC)),1)
	CPPFLAGS += -DNORL
else
	LDLIBS += -lreadline
endif

ifeq ($(strip $(O_PCRE)),1)
	CPPFLAGS += -DPCRE
	LDLIBS += -lpcre
endif

ifeq ($(strip $(O_NOLC)),1)
	ifeq ($(strip $(O_ICONS)),1)
$(info *** Ignoring O_NOLC since O_ICONS is set ***)
	else ifeq ($(strip $(O_NERD)),1)
$(info *** Ignoring O_NOLC since O_NERD is set ***)
	else
		CPPFLAGS += -DNOLC
	endif
endif

ifeq ($(strip $(O_NOMOUSE)),1)
	CPPFLAGS += -DNOMOUSE
endif

ifeq ($(strip $(O_NOBATCH)),1)
	CPPFLAGS += -DNOBATCH
endif

ifeq ($(strip $(O_NOFIFO)),1)
	CPPFLAGS += -DNOFIFO
endif

ifeq ($(strip $(O_CTX8)),1)
	CPPFLAGS += -DCTX8
endif

ifeq ($(strip $(O_ICONS)),1)
	CPPFLAGS += -DICONS
endif

ifeq ($(strip $(O_NERD)),1)
	CPPFLAGS += -DNERD
endif

ifeq ($(strip $(O_QSORT)),1)
	CPPFLAGS += -DTOURBIN_QSORT
endif

ifeq ($(strip $(O_BENCH)),1)
	CPPFLAGS += -DBENCH
endif

ifeq ($(strip $(O_NOSSN)),1)
	CPPFLAGS += -DNOSSN
endif

ifeq ($(strip $(O_NOUG)),1)
	CPPFLAGS += -DNOUG
endif

ifeq ($(strip $(O_NOX11)),1)
	CPPFLAGS += -DNOX11
endif

ifeq ($(strip $(O_MATCHFLTR)),1)
	CPPFLAGS += -DMATCHFLTR
endif

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
else ifeq ($(shell $(PKG_CONFIG) ncurses && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncurses)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncurses)
else
	LDLIBS_CURSES ?= -lncurses
endif

CFLAGS += -std=c11 -Wall -Wextra -Wshadow
CFLAGS += $(CFLAGS_OPTIMIZATION)
CFLAGS += $(CFLAGS_CURSES)

LDLIBS += $(LDLIBS_CURSES) -lpthread

# static compilation needs libgpm development package
ifeq ($(strip $(O_STATIC)),1)
	LDFLAGS += -static
	LDLIBS += -lgpm
endif

DISTFILES = src nnn.1 Makefile README.md LICENSE
SRC = src/nnn.c
HEADERS = src/nnn.h
BIN = nnn
DESKTOPFILE = misc/desktop/nnn.desktop
LOGOSVG = misc/logo/logo.svg
LOGO64X64 = misc/logo/logo-64x64.png

GITSTATUS = patches/gitstatus
NAMEFIRST = patches/namefirst
RESTOREPREVIEW = patches/restorepreview

# test if we are on Mac OS X and get X.Y.Z OS version with system binary /usr/bin/sw_vers
MACOS_VERSION := $(strip $(shell command -v sw_vers >/dev/null && [ "`sw_vers -productName`" = "Mac OS X" ] && sw_vers -productVersion))
# if Mac OS X detected, test if its version is below 10.12.0 relying on "sort -c" returning "disorder" message if the input is not sorted
ifneq ($(MACOS_VERSION),)
	MACOS_BELOW_1012 := $(if $(strip $(shell printf '10.12.0\n%s' "$(MACOS_VERSION)" | sort -ct. -k1,1n -k2,2n -k3,3n 2>&1)),1)
endif
# if Mac OS X version is below 10.12.0, compile in the replacement clock_gettime and define MACOS_BELOW_1012 so that it's included in nnn.c
ifneq ($(MACOS_BELOW_1012),)
	GETTIME_C = misc/macos-legacy/mach_gettime.c
	GETTIME_H = misc/macos-legacy/mach_gettime.h
	SRC += $(GETTIME_C)
	HEADERS += $(GETTIME_H)
	CPPFLAGS += -DMACOS_BELOW_1012
endif

all: $(BIN)

$(BIN): $(SRC) $(HEADERS)
	@$(MAKE) --silent prepatch
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(GETTIME_C) $< $(LDLIBS)
	@$(MAKE) --silent postpatch

# targets for backwards compatibility
debug: $(BIN)
norl: $(BIN)
nolc: $(BIN)

install-desktop: $(DESKTOPFILE)
	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPPREFIX)
	$(INSTALL) -m 0644 $(DESKTOPFILE) $(DESTDIR)$(DESKTOPPREFIX)
	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps
	$(INSTALL) -m 0644 $(LOGOSVG) $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps/nnn.svg
	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps
	$(INSTALL) -m 0644 $(LOGO64X64) $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps/nnn.png

uninstall-desktop:
	$(RM) $(DESTDIR)$(DESKTOPPREFIX)/$(DESKTOPFILE)
	$(RM) $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps/nnn.svg
	$(RM) $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps/nnn.png

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

upx: $(BIN)
	$(STRIP) $^
	upx -qqq $^

static:
	# regular static binary
	make O_STATIC=1 strip
	mv $(BIN) $(BIN)-static
	# static binary with icons-in-terminal support
	make O_STATIC=1 O_ICONS=1 strip
	mv $(BIN) $(BIN)-icons-static
	# static binary with patched nerd font support
	make O_STATIC=1 O_NERD=1 strip
	mv $(BIN) $(BIN)-nerd-static

musl:
	cp misc/musl/musl-static-ubuntu.sh .
	./musl-static-ubuntu.sh 1
	rm ./musl-static-ubuntu.sh

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) -r $(DISTFILES) nnn-$(VERSION)
	tar -cf - nnn-$(VERSION) | gzip > nnn-$(VERSION).tar.gz
	$(RM) -r nnn-$(VERSION)

sign:
	git archive -o nnn-$(VERSION).tar.gz --format tar.gz --prefix=nnn-$(VERSION)/ v$(VERSION)
	gpg --detach-sign --yes nnn-$(VERSION).tar.gz
	rm -f nnn-$(VERSION).tar.gz

upload-local: sign static musl
	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
	# upload sign file
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
	    --upload-file nnn-$(VERSION).tar.gz.sig
	# upx compress all static binaries
	upx -qqq $(BIN)-static
	upx -qqq $(BIN)-icons-static
	upx -qqq $(BIN)-nerd-static
	# upload static binary
	tar -zcf $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-static
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-static-$(VERSION).x86_64.tar.gz' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-static-$(VERSION).x86_64.tar.gz
	# upload icons-in-terminal compiled static binary
	tar -zcf $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-icons-static-$(VERSION).x86_64.tar.gz' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-icons-static-$(VERSION).x86_64.tar.gz
	# upload patched nerd font compiled static binary
	tar -zcf $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-nerd-static-$(VERSION).x86_64.tar.gz' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz
	# upload musl static binary
	tar -zcf $(BIN)-musl-static-$(VERSION).x86_64.tar.gz $(BIN)-musl-static
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-musl-static-$(VERSION).x86_64.tar.gz' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-musl-static-$(VERSION).x86_64.tar.gz

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz $(BIN)-musl-static $(BIN)-musl-static-$(VERSION).x86_64.tar.gz

prepatch:
ifeq ($(strip $(O_NAMEFIRST)),1)
	patch --forward --strip=1 --input=$(NAMEFIRST)/mainline.diff
ifeq ($(strip $(O_GITSTATUS)),1)
	patch --forward --strip=1 --input=$(GITSTATUS)/namefirst.diff
endif
else ifeq ($(strip $(O_GITSTATUS)),1)
	patch --forward --strip=1 --input=$(GITSTATUS)/mainline.diff
endif
ifeq ($(strip $(O_RESTOREPREVIEW)),1)
	patch --forward --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
endif

postpatch:
ifeq ($(strip $(O_NAMEFIRST)),1)
ifeq ($(strip $(O_GITSTATUS)),1)
	patch --reverse --strip=1 --input=$(GITSTATUS)/namefirst.diff
endif
	patch --reverse --strip=1 --input=$(NAMEFIRST)/mainline.diff
else ifeq ($(strip $(O_GITSTATUS)),1)
	patch --reverse --strip=1 --input=$(GITSTATUS)/mainline.diff
endif
ifeq ($(strip $(O_RESTOREPREVIEW)),1)
	patch --reverse --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
endif

skip: ;

.PHONY: all install uninstall strip static dist sign upload-local clean install-desktop uninstall-desktop

=== debian/changelog ===
nnn (4.3-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump Standards-Version to 4.6.0.1

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 30 Sep 2021 14:55:51 +0800

nnn (4.2-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump Standards-Version to 4.5.1
  * d/tests:
    - Redirect stderr output for parsing testing string

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 05 Sep 2021 16:29:45 +0800

=== debian/control ===
Source: nnn
Section: misc
Priority: optional
Maintainer: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: debhelper-compat (= 13),
               libncurses-dev,
               libreadline-dev,
               pkg-config
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://github.com/jarun/nnn
Vcs-Git: https://salsa.debian.org/debian/nnn.git
Vcs-Browser: https://salsa.debian.org/debian/nnn

Package: nnn
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         readline-common
Suggests: mediainfo | exiftool,
          atool | patool,
          vlock,
          file,
          lftp,
          sshfs,
          xdg-utils
Description: Free, fast, friendly file manager
 nnn is a fork of noice, a blazing-fast lightweight terminal file manager
 with easy keyboard shortcuts for navigation, opening files and running tasks.
 nnn toppings
 .
  - Show details of the currently selected file (stat, file)
  - Disk usage analyzer mode (within the same fs, doesn't follow symlinks)
  - Directories first (even with sorting)
  - Sort numeric names in numeric order
  - Case-insensitive alphabetic content listing instead of upper case first
  - Key - to jump to last visited directory
  - Roll over at the first and last entries of a directory
  - Removed navigation restriction with relative paths
  - Sort entries by file size (largest to smallest)
  - Shortcut to invoke file name copier

## nnn 4.5

=== Makefile ===
--- 
+++ 
@@ -27,6 +27,7 @@
 O_NOUG := 0  # disable user, group name in status bar
 O_NOX11 := 0  # disable X11 integration
 O_MATCHFLTR := 0  # allow filters without matches
+O_NOSORT := 0  # disable sorting entries on dir load
 
 # User patches
 O_GITSTATUS := 0 # add git status to detail view
@@ -121,6 +122,10 @@
 	CPPFLAGS += -DMATCHFLTR
 endif
 
+ifeq ($(strip $(O_NOSORT)),1)
+	CPPFLAGS += -DNOSORT
+endif
+
 ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
 	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
 	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
@@ -172,7 +177,7 @@
 
 all: $(BIN)
 
-$(BIN): $(SRC) $(HEADERS)
+$(BIN): $(SRC) $(HEADERS) Makefile
 	@$(MAKE) --silent prepatch
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(GETTIME_C) $< $(LDLIBS)
 	@$(MAKE) --silent postpatch

=== debian/changelog ===
nnn (4.5-1) unstable; urgency=medium

  * Import new upstrem version
  * Update copyright

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 27 Apr 2022 10:03:59 +0800

nnn (4.4-1) unstable; urgency=medium

  * Import new upstrem version
  * Update copyright

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 05 Dec 2021 21:34:15 +0800

## nnn 4.7

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
 O_CTX8 := 0  # enable 8 contexts
 O_ICONS := 0  # support icons-in-terminal
 O_NERD := 0  # support icons-nerdfont
+O_EMOJI := 0  # support emoji
 O_QSORT := 0  # use Alexey Tourbin's QSORT implementation
 O_BENCH := 0  # benchmark mode (stops at first user input)
 O_NOSSN := 0  # disable session support
@@ -30,6 +31,7 @@
 O_NOSORT := 0  # disable sorting entries on dir load
 
 # User patches
+O_COLEMAK := 0 # change key bindings to colemak compatible layout
 O_GITSTATUS := 0 # add git status to detail view
 O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view
 O_RESTOREPREVIEW := 0 # add preview pipe to close and restore preview pane
@@ -69,6 +71,8 @@
 $(info *** Ignoring O_NOLC since O_ICONS is set ***)
 	else ifeq ($(strip $(O_NERD)),1)
 $(info *** Ignoring O_NOLC since O_NERD is set ***)
+	else ifeq ($(strip $(O_EMOJI)),1)
+$(info *** Ignoring O_NOLC since O_EMOJI is set ***)
 	else
 		CPPFLAGS += -DNOLC
 	endif
@@ -91,11 +95,18 @@
 endif
 
 ifeq ($(strip $(O_ICONS)),1)
-	CPPFLAGS += -DICONS
+	ICONS_INCLUDE = icons-generated-icons-in-term.h
+	CPPFLAGS += -DICONS_IN_TERM -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
 endif
 
 ifeq ($(strip $(O_NERD)),1)
-	CPPFLAGS += -DNERD
+	ICONS_INCLUDE = icons-generated-nerd.h
+	CPPFLAGS += -DNERD -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+endif
+
+ifeq ($(strip $(O_EMOJI)),1)
+	ICONS_INCLUDE = icons-generated-emoji.h
+	CPPFLAGS += -DEMOJI -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
 endif
 
 ifeq ($(strip $(O_QSORT)),1)
@@ -156,6 +167,7 @@
 LOGOSVG = misc/logo/logo.svg
 LOGO64X64 = misc/logo/logo-64x64.png
 
+COLEMAK = patches/colemak
 GITSTATUS = patches/gitstatus
 NAMEFIRST = patches/namefirst
 RESTOREPREVIEW = patches/restorepreview
@@ -175,6 +187,22 @@
 	CPPFLAGS += -DMACOS_BELOW_1012
 endif
 
+ifeq ($(strip $(O_DEBUG)),1)
+	HEADERS += src/dbg.h
+endif
+ifeq ($(strip $(O_QSORT)),1)
+	HEADERS += src/qsort.h
+endif
+ifeq ($(strip $(O_EMOJI)),1)
+	HEADERS += src/icons.h src/$(ICONS_INCLUDE)
+endif
+ifeq ($(strip $(O_NERD)),1)
+	HEADERS += src/icons.h src/$(ICONS_INCLUDE)
+endif
+ifeq ($(strip $(O_ICONS)),1)
+	HEADERS += src/icons.h src/$(ICONS_INCLUDE) src/icons-in-terminal.h
+endif
+
 all: $(BIN)
 
 $(BIN): $(SRC) $(HEADERS) Makefile
@@ -186,6 +214,10 @@
 debug: $(BIN)
 norl: $(BIN)
 nolc: $(BIN)
+
+src/$(ICONS_INCLUDE): src/icons-hash.c src/icons.h src/icons-in-terminal.h
+	$(CC) $(CPPFLAGS) -DICONS_GENERATE -o src/icons-hash-gen src/icons-hash.c
+	./src/icons-hash-gen > $@
 
 install-desktop: $(DESKTOPFILE)
 	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPPREFIX)
@@ -227,11 +259,17 @@
 	# static binary with patched nerd font support
 	make O_STATIC=1 O_NERD=1 strip
 	mv $(BIN) $(BIN)-nerd-static
+	# static binary with emoji support
+	make O_STATIC=1 O_EMOJI=1 strip
+	mv $(BIN) $(BIN)-emoji-static
 
 musl:
 	cp misc/musl/musl-static-ubuntu.sh .
 	./musl-static-ubuntu.sh 1
 	rm ./musl-static-ubuntu.sh
+
+shellcheck:
+	find ./plugins/ -type f -not -name "*.md" -exec shellcheck {} +
 
 dist:
 	mkdir -p nnn-$(VERSION)
@@ -254,6 +292,7 @@
 	upx -qqq $(BIN)-static
 	upx -qqq $(BIN)-icons-static
 	upx -qqq $(BIN)-nerd-static
+	upx -qqq $(BIN)-emoji-static
 	# upload static binary
 	tar -zcf $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-static
 	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-static-$(VERSION).x86_64.tar.gz' \
@@ -269,6 +308,11 @@
 	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-nerd-static-$(VERSION).x86_64.tar.gz' \
 	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
 	    --upload-file $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz
+	# upload emoji compiled static binary
+	tar -zcf $(BIN)-emoji-static-$(VERSION).x86_64.tar.gz $(BIN)-emoji-static
+	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-emoji-static-$(VERSION).x86_64.tar.gz' \
+	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
+	    --upload-file $(BIN)-emoji-static-$(VERSION).x86_64.tar.gz
 	# upload musl static binary
 	tar -zcf $(BIN)-musl-static-$(VERSION).x86_64.tar.gz $(BIN)-musl-static
 	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-musl-static-$(VERSION).x86_64.tar.gz' \
@@ -276,34 +320,37 @@
 	    --upload-file $(BIN)-musl-static-$(VERSION).x86_64.tar.gz
 
 clean:
-	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz $(BIN)-musl-static $(BIN)-musl-static-$(VERSION).x86_64.tar.gz
+	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz $(BIN)-emoji-static $(BIN)-emoji-static-$(VERSION).x86_64.tar.gz $(BIN)-musl-static $(BIN)-musl-static-$(VERSION).x86_64.tar.gz src/icons-hash-gen src/icons-generated-*.h
+
+checkpatches:
+	./patches/check-patches.sh
 
 prepatch:
 ifeq ($(strip $(O_NAMEFIRST)),1)
-	patch --forward --strip=1 --input=$(NAMEFIRST)/mainline.diff
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(NAMEFIRST)/mainline.diff
 ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --forward --strip=1 --input=$(GITSTATUS)/namefirst.diff
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/namefirst.diff
 endif
 else ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --forward --strip=1 --input=$(GITSTATUS)/mainline.diff
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/mainline.diff
 endif
 ifeq ($(strip $(O_RESTOREPREVIEW)),1)
-	patch --forward --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
+endif
+ifeq ($(strip $(O_COLEMAK)),1)
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK)/mainline.diff
 endif
 
 postpatch:
 ifeq ($(strip $(O_NAMEFIRST)),1)
 ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --reverse --strip=1 --input=$(GITSTATUS)/namefirst.diff
-endif
-	patch --reverse --strip=1 --input=$(NAMEFIRST)/mainline.diff
+	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/namefirst.diff
+endif
+	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(NAMEFIRST)/mainline.diff
 else ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --reverse --strip=1 --input=$(GITSTATUS)/mainline.diff
+	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/mainline.diff
 endif
 ifeq ($(strip $(O_RESTOREPREVIEW)),1)
-	patch --reverse --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
-endif
-
-skip: ;
-
-.PHONY: all install uninstall strip static dist sign upload-local clean install-desktop uninstall-desktop
+	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
+endif
+ifeq ($(strip $(O_COLEMAK)),1)

=== debian/changelog ===
nnn (4.7-1) unstable; urgency=medium

  * Import new upstrem version
  * d/watch:
    - Fix format issue (Closes:#1024777)

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 03 Dec 2022 22:49:54 +0800

nnn (4.6-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.6.1.0

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 19 Aug 2022 12:18:36 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nnn-$1\.tar\.gz/ \
   https://github.com/jarun/nnn/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## nnn 4.8

=== debian/changelog ===
nnn (4.8-1) stable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Tue, 30 Sep 2025 23:39:54 +0000

nnn (4.8) stable; urgency=low

- nnn v4.8 Spritz release notes.

  * show total size (key S) of non-filtered selection in a directory
  * fix tilde (~) handling in file name
  * plugin .nmv now respects -u flag
  * env var $NNN_PREFER_SELECTION exported to all plugins
  * support for wezterm in preview-tui
  * create new file or directory (tree) on startup
  * run command as plugin now supports exported variables
  * use "$nnn" anywhere when running command as plugin
  * set defaults for some prompts on Enter
  * improve archive, rename and create new workflows
  * optimize link creation
  * allow overwriting regular files on new empty file creation
  * add patch for colemak keyboard (existing renamed to colemak-dh)
  * add correct check for Wayland in clipboard plugins
  * add quitcd script for nushell
  * plugin kdeconnect - send multiple files
  * plugin preview-tui: add chafa as preferred image viewer, multiple fixes
  * plugin nmount - misc. improvements
  * add icon for jxl files
  * Modify correct copyright years

  -- Nicolas FORMICHELLA <stigpro@outlook.fr> Fri, 14 Apr 13:00:00 +0000

nnn (4.7) stable; urgency=low

-nnn v4.7 Cuba libre release notes.

  * fix ^N not working sometimes (#1449)
  * fix file remove confirmation prompt [Esc - cancel, y/Y - use force, any other key - prompt for each file]
  * bring back atool as the default archive handler
  * add option -B to use bsdtar as the archive utility
  * find and list mode improvements
    * continue even if max paths/data size limit is exceeded
    * speed improvements
    * support listing maximum 16K paths of 64 MiB of data
  * key J to jump to an entry or relative offset from current entry
  * prefill the hard link creation prompt when there's a single target (#1507)
  * documented workaround for docker container crash (#1407, #1476)
  * plugin imgview: handle arguments as strings (#1509)
  * plugin wallpaper: support Wayland (#1512)
  * plugin upload: handle selection using ffsend (#1523)
  * add Rust icons (#1502)

  -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.6) stable; urgency=low

  * icon handling overhaul for better performance, memory usage and reduced binary size (#1432, #1436)
  * emoji support for supporting distros and terminals (#1346)
  * open the target directory of symlinked bookmarks (#1353)
  * enable show hidden when a hidden file is passed as argument
  * add Colemak-DH layout keybinds to patch framework (#1421)
  * set bsdtar as the default archive utility
  * support 4 byte unicode keybinds (#1428)
  * enable directory auto-enter during filter operation (-A to disable)
  * enable filter prompt inside the bookmark/plugin dirs
  * show volume usage information in help
  * add Elixir icons (#1437)
  * add new icon colors for mp4 and flac files
  * use stat -x for file details on *BSD and macOS (#1389)
  * interpret suffix $nnn when paging (#1355)
  * disable key e (edit file) in explorer mode (#1394)
  * fix double order chars on filter case match change
  * .cbcp: more verbose message on paste without a selection
  * plugin preview-tui: scale-up kitty previews
  * plugin preview-tui: account for ueberzug offset
  * plugin preview-tui: support SPLIT_SIZE for preview pane (#1431)
  * plugin autojump: support z.lua
  * new Makefile target shellcheck to verify plugins

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.5) stable; urgency=low

  * Prepare for release v4.5 Cachaça
  * Fix patch conflicts and rebase
  * Use bold forward arrowhead for current
  * Add 2 spaces after icons for better visibility
  * Fix #1345: allow symlink name '@' in single file case
  * quitcd script for Elvish shell > 0.17.0
  * Handle broken window if started in type-to-nav
  * Bind ^J with toggle auto-jump on open
  * Replace ^J with + to (un)select
  * consistently use ELEMENTS macro

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 27 Jul 2022 05:50:00 +0000

nnn (4.4) stable; urgency=low

- support macOS iterm2 in plugin preview-tui (#1196)
- use selection at native command prompt with %j and %J (docs)
- scroll strings longer than columns in rename/new prompts (#1213, #279)
- batch rename symlink targets in listing mode (#1214)
- option for recursive rename in plugin .nmv (#1186)
- more frequent checks for cancellation during du (#1236)
- picker mode: enable auto-proceed
- picker mode: don't pick hovered file on Enter if selection exists
- picker mode: fix issue in plugin fzopen when used to pick files
- send file to explorer FIFO on double left click instead of opening it
- new neovim plugin nnn.nvim featuring explorer mode
- explorer mode for nnn.vim
- remove option -w: always place HW cursor on current entry
- accept link name when linking a single target (#1201)
- option -i to show current file information in info bar
- force GNU sed on *BSD and Solaris
- add nsxiv support to nuke, preview-tabbed and imgview (#1230)
- fix preview-tui without -a (#1208)
- pass pts in env var for preview-tui to use in tput (#1235)
- disable editing file in picker mode (#1183)
- save session in picker mode (#1190)
- use nerd icons for gitstatus patch (#1220)

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 24 Now 2021 07:00:00 +0100

nnn (4.3-1) stable; urgency=low

  * Added completions

 -- Nicolas FORMICHELLA <stigpro@outlook.fr> Wed, 29 Sep 2021 22:21:00 +022

nnn (4.3) stable; urgency=low

  *    cool ASCII art logo in the help screen
  *    add bookmarks directory for flexible symlinked bookmarks
  *    new key B to add a symlinked bookmark for current dir
  *    special variables $dN, $fN available for plugins/prompt/shell to access per-context dir/hovered file
  *    config NNN_ORDER to set directory-specific ordering
  *    show/hide hidden files as per context state in plugin based batch rename


=== debian/control ===
Source: nnn
Section: utilities
Priority: optional
Maintainer: Nicolas FORMICHELLA <stigpro@outlook.fr>
Build-Depends: debhelper (>= 9), pkg-config, make, gcc, libreadline-dev | libreadline6-dev, libncurses-dev | libncursesw5-dev

Package: nnn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The unorthodox terminal file manager

=== debian/rules ===
#!/usr/bin/make -f
# vim: syntax=make
#export DH_VERBOSE = 1

VERSION := 4.8

export DESTROOT=$(CURDIR)/debian

DEB_TARGET_GNU_CPU ?= $(DEB_BUILD_GNU_CPU)

%:
	dh $@

override_dh_auto_clean:

override_dh_auto_build:
	make strip

override_dh_auto_install:
	mkdir -p $(DESTROOT)/nnn/usr/bin
	cp nnn $(DESTROOT)/nnn/usr/bin
	mkdir -p $(DESTROOT)/usr/share/bash-completion/completions/
	mkdir -p $(DESTROOT)/usr/share/fish/vendor_completions.d/
	mkdir -p $(DESTROOT)/usr/share/zsh/site-functions/
	install -Dm0644 misc/auto-completion/fish/nnn.fish $(DESTROOT)/usr/share/fish/vendor_completions.d/nnn.fish
	install -Dm0644 misc/auto-completion/bash/nnn-completion.bash $(DESTROOT)/usr/share/bash-completion/completions/nnn
	install -Dm0644 misc/auto-completion/zsh/_nnn $(DESTROOT)/usr/share/zsh/site-functions/_nnn

## nnn 4.9

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 
 # User patches
 O_COLEMAK := 0 # change key bindings to colemak compatible layout
+O_COLEMAK-DH := 0 # change key bindings to colemak-dh compatible layout
 O_GITSTATUS := 0 # add git status to detail view
 O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view
 O_RESTOREPREVIEW := 0 # add preview pipe to close and restore preview pane
@@ -50,7 +51,7 @@
 
 ifeq ($(strip $(O_DEBUG)),1)
 	CPPFLAGS += -DDEBUG
-	CFLAGS += -g
+	CFLAGS += -g3
 endif
 
 ifeq ($(strip $(O_NORL)),1)
@@ -168,6 +169,7 @@
 LOGO64X64 = misc/logo/logo-64x64.png
 
 COLEMAK = patches/colemak
+COLEMAK-DH = patches/colemak-dh
 GITSTATUS = patches/gitstatus
 NAMEFIRST = patches/namefirst
 RESTOREPREVIEW = patches/restorepreview
@@ -216,7 +218,7 @@
 nolc: $(BIN)
 
 src/$(ICONS_INCLUDE): src/icons-hash.c src/icons.h src/icons-in-terminal.h
-	$(CC) $(CPPFLAGS) -DICONS_GENERATE -o src/icons-hash-gen src/icons-hash.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DICONS_GENERATE -o src/icons-hash-gen src/icons-hash.c
 	./src/icons-hash-gen > $@
 
 install-desktop: $(DESKTOPFILE)
@@ -340,6 +342,9 @@
 ifeq ($(strip $(O_COLEMAK)),1)
 	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK)/mainline.diff
 endif
+ifeq ($(strip $(O_COLEMAK-DH)),1)
+	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK-DH)/mainline.diff
+endif
 
 postpatch:
 ifeq ($(strip $(O_NAMEFIRST)),1)
@@ -348,9 +353,3 @@
 endif
 	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(NAMEFIRST)/mainline.diff
 else ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/mainline.diff
-endif
-ifeq ($(strip $(O_RESTOREPREVIEW)),1)
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(RESTOREPREVIEW)/mainline.diff
-endif
-ifeq ($(strip $(O_COLEMAK)),1)

=== debian/changelog ===
nnn (4.9-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:46 +1100

nnn (4.9-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:58:54 +0100

nnn (4.9-1) unstable; urgency=medium

  * Import new upstrem version

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 10 Sep 2023 20:12:40 +0800

nnn (4.8-1) unstable; urgency=medium

  * Import new upstrem version
  * Update d/copyright
  * d/control:
    - Bump Standards-Version to 4.6.2

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 16 Jul 2023 17:21:36 +0800

=== debian/control ===
Source: nnn
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: debhelper-compat (= 13),
               libncurses-dev,
               libreadline-dev,
               pkg-config
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/jarun/nnn
Vcs-Git: https://salsa.debian.org/debian/nnn.git
Vcs-Browser: https://salsa.debian.org/debian/nnn

Package: nnn
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         readline-common
Suggests: mediainfo | exiftool,
          atool | patool,
          vlock,
          file,
          lftp,
          sshfs,
          xdg-utils
Description: Free, fast, friendly file manager
 nnn is a fork of noice, a blazing-fast lightweight terminal file manager
 with easy keyboard shortcuts for navigation, opening files and running tasks.
 nnn toppings
 .
  - Show details of the currently selected file (stat, file)
  - Disk usage analyzer mode (within the same fs, doesn't follow symlinks)
  - Directories first (even with sorting)
  - Sort numeric names in numeric order
  - Case-insensitive alphabetic content listing instead of upper case first
  - Key - to jump to last visited directory
  - Roll over at the first and last entries of a directory
  - Removed navigation restriction with relative paths
  - Sort entries by file size (largest to smallest)
  - Shortcut to invoke file name copier

## nnn 5.0

=== debian/changelog ===
nnn (5.0-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.7.0

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 02 Sep 2024 14:37:24 +0800

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: nnn
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: SZ Lin (林上智) <szlin@debian.org>
+Maintainer: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
                libreadline-dev,
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git

## nnn 5.1

=== Makefile ===
--- 
+++ 
@@ -32,10 +32,11 @@
 
 # User patches
 O_COLEMAK := 0 # change key bindings to colemak compatible layout
-O_COLEMAK-DH := 0 # change key bindings to colemak-dh compatible layout
 O_GITSTATUS := 0 # add git status to detail view
 O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view
 O_RESTOREPREVIEW := 0 # add preview pipe to close and restore preview pane
+
+T_ICONS := 0 # test if multiple icons options are set and fail
 
 # convert targets to flags for backwards compatibility
 ifneq ($(filter debug,$(MAKECMDGOALS)),)
@@ -98,16 +99,28 @@
 ifeq ($(strip $(O_ICONS)),1)
 	ICONS_INCLUDE = icons-generated-icons-in-term.h
 	CPPFLAGS += -DICONS_IN_TERM -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_NERD)),1)
 	ICONS_INCLUDE = icons-generated-nerd.h
 	CPPFLAGS += -DNERD -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_EMOJI)),1)
 	ICONS_INCLUDE = icons-generated-emoji.h
 	CPPFLAGS += -DEMOJI -DICONS_INCLUDE=\"$(ICONS_INCLUDE)\"
+ifeq ($(strip $(T_ICONS)),1)
+$(error Choose only one system for icons (O_ICONS, O_NERD or O_EMOJI))
+endif
+	T_ICONS := 1
 endif
 
 ifeq ($(strip $(O_QSORT)),1)
@@ -169,7 +182,6 @@
 LOGO64X64 = misc/logo/logo-64x64.png
 
 COLEMAK = patches/colemak
-COLEMAK-DH = patches/colemak-dh
 GITSTATUS = patches/gitstatus
 NAMEFIRST = patches/namefirst
 RESTOREPREVIEW = patches/restorepreview
@@ -342,14 +354,7 @@
 ifeq ($(strip $(O_COLEMAK)),1)
 	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK)/mainline.diff
 endif
-ifeq ($(strip $(O_COLEMAK-DH)),1)
-	patch --forward $(PATCH_OPTS) --strip=1 --input=$(COLEMAK-DH)/mainline.diff
-endif
 
 postpatch:
 ifeq ($(strip $(O_NAMEFIRST)),1)
 ifeq ($(strip $(O_GITSTATUS)),1)
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(GITSTATUS)/namefirst.diff
-endif
-	patch --reverse $(PATCH_OPTS) --strip=1 --input=$(NAMEFIRST)/mainline.diff
-else ifeq ($(strip $(O_GITSTATUS)),1)

=== misc/haiku/Makefile ===
VERSION = $(shell grep -m1 VERSION $(SRC) | cut -f 2 -d'"')

PREFIX ?= /boot/system/non-packaged
MANPREFIX ?= $(PREFIX)/documentation/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install
CP ?= cp

CFLAGS_OPTIMIZATION ?= -O3

O_DEBUG := 0  # debug binary
O_NORL := 0  # no readline support
O_PCRE := 0  # link with PCRE library
O_NOLC := 0  # no locale support
O_NOMOUSE := 0  # no mouse support
O_NOBATCH := 0  # no built-in batch renamer
O_NOFIFO := 0  # no FIFO previewer support
O_CTX8 := 0  # enable 8 contexts
O_ICONS := 0  # support icons-in-terminal
O_NERD := 0  # support icons-nerdfont
O_QSORT := 0  # use Alexey Tourbin's QSORT implementation
O_BENCH := 0  # benchmark mode (stops at first user input)
O_NOSSN := 0  # disable session support
O_NOUG := 0  # disable user, group name in status bar
O_NOX11 := 0  # disable X11 integration
O_MATCHFLTR := 0  # allow filters without matches

# User patches
O_GITSTATUS := 0 # add git status to detail view
O_NAMEFIRST := 0 # print file name first, add uid and guid to detail view

ifeq ($(strip $(O_GITSTATUS)),1)
	LDLIBS += -lgit2
endif

# convert targets to flags for backwards compatibility
ifneq ($(filter debug,$(MAKECMDGOALS)),)
	O_DEBUG := 1
endif
ifneq ($(filter norl,$(MAKECMDGOALS)),)
	O_NORL := 1
endif
ifneq ($(filter nolc,$(MAKECMDGOALS)),)
	O_NORL := 1
	O_NOLC := 1
endif

ifeq ($(strip $(O_DEBUG)),1)
	CPPFLAGS += -DDEBUG
	CFLAGS += -g
	LDLIBS += -lrt
endif

ifeq ($(strip $(O_NORL)),1)
	CPPFLAGS += -DNORL
else ifeq ($(strip $(O_STATIC)),1)
	CPPFLAGS += -DNORL
else
	LDLIBS += -lreadline
endif

ifeq ($(strip $(O_PCRE)),1)
	CPPFLAGS += -DPCRE
	LDLIBS += -lpcre
endif

ifeq ($(strip $(O_NOLC)),1)
	ifeq ($(strip $(O_ICONS)),1)
$(info *** Ignoring O_NOLC since O_ICONS is set ***)
	else ifeq ($(strip $(O_NERD)),1)
$(info *** Ignoring O_NOLC since O_NERD is set ***)
	else
		CPPFLAGS += -DNOLC
	endif
endif

ifeq ($(strip $(O_NOMOUSE)),1)
	CPPFLAGS += -DNOMOUSE
endif

ifeq ($(strip $(O_NOBATCH)),1)
	CPPFLAGS += -DNOBATCH
endif

ifeq ($(strip $(O_NOFIFO)),1)
	CPPFLAGS += -DNOFIFO
endif

ifeq ($(strip $(O_CTX8)),1)
	CPPFLAGS += -DCTX8
endif

ifeq ($(strip $(O_ICONS)),1)
	CPPFLAGS += -DICONS
endif

ifeq ($(strip $(O_NERD)),1)
	CPPFLAGS += -DNERD
endif

ifeq ($(strip $(O_QSORT)),1)
	CPPFLAGS += -DTOURBIN_QSORT
endif

ifeq ($(strip $(O_BENCH)),1)
	CPPFLAGS += -DBENCH
endif

ifeq ($(strip $(O_NOSSN)),1)
	CPPFLAGS += -DNOSSN
endif

ifeq ($(strip $(O_NOUG)),1)
	CPPFLAGS += -DNOUG
endif

ifeq ($(strip $(O_NOX11)),1)
	CPPFLAGS += -DNOX11
endif

ifeq ($(strip $(O_MATCHFLTR)),1)
	CPPFLAGS += -DMATCHFLTR
endif

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
else ifeq ($(shell $(PKG_CONFIG) ncurses && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncurses)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncurses)
else
	LDLIBS_CURSES ?= -lncurses
endif

ifeq ($(shell uname -s), Haiku)
	LDLIBS_HAIKU ?= -lstdc++ -lgnu -lbe
	SRC_HAIKU ?= misc/haiku/nm.cpp
	OBJS_HAIKU ?= misc/haiku/nm.o
endif

CFLAGS += -std=c11 -Wall -Wextra -Wshadow
CFLAGS += $(CFLAGS_OPTIMIZATION)
CFLAGS += $(CFLAGS_CURSES)

LDLIBS += $(LDLIBS_CURSES) -lpthread $(LDLIBS_HAIKU)
# static compilation needs libgpm development package
ifeq ($(strip $(O_STATIC)),1)
	LDFLAGS += -static
	LDLIBS += -lgpm
endif

DISTFILES = src nnn.1 Makefile README.md LICENSE
SRC = src/nnn.c
HEADERS = src/nnn.h
BIN = nnn
OBJS := nnn.o $(OBJS_HAIKU)

GITSTATUS = patches/gitstatus
NAMEFIRST = patches/namefirst

all: $(BIN)

ifeq ($(shell uname -s), Haiku)
$(OBJS_HAIKU): $(SRC_HAIKU)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<
endif

nnn.o: $(SRC) $(HEADERS)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

$(BIN): $(OBJS)
	@$(MAKE) --silent prepatch
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)
	@$(MAKE) --silent postpatch

# targets for backwards compatibility
debug: $(BIN)
norl: $(BIN)
nolc: $(BIN)

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

static:
	# regular static binary
	make O_STATIC=1 strip
	mv $(BIN) $(BIN)-static

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) -r $(DISTFILES) nnn-$(VERSION)
	mkdir -p nnn-$(VERSION)/misc
	$(CP) -r misc/haiku nnn-$(VERSION)/misc
	tar -cf - nnn-$(VERSION) | gzip > nnn-$(VERSION).tar.gz
	$(RM) -r nnn-$(VERSION)

sign:
	git archive -o nnn-$(VERSION).tar.gz --format tar.gz --prefix=nnn-$(VERSION)/ v$(VERSION)
	gpg --detach-sign --yes nnn-$(VERSION).tar.gz
	rm -f nnn-$(VERSION).tar.gz

upload-local: sign static
	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
	# upload sign file
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
	    --upload-file nnn-$(VERSION).tar.gz.sig
	tar -zcf $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-static
	# upload static binary
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-static-$(VERSION).x86_64.tar.gz' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-static-$(VERSION).x86_64.tar.gz

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz

prepatch:
ifeq ($(strip $(O_NAMEFIRST)),1)
	patch --forward --strip=1 --input=$(NAMEFIRST)/mainline.diff
ifeq ($(strip $(O_GITSTATUS)),1)
	patch --forward --strip=1 --input=$(GITSTATUS)/namefirst.diff
endif
else ifeq ($(strip $(O_GITSTATUS)),1)
	patch --forward --strip=1 --input=$(GITSTATUS)/mainline.diff
endif

postpatch:
ifeq ($(strip $(O_NAMEFIRST)),1)
ifeq ($(strip $(O_GITSTATUS)),1)
	patch --reverse --strip=1 --input=$(GITSTATUS)/namefirst.diff
endif
	patch --reverse --strip=1 --input=$(NAMEFIRST)/mainline.diff
else ifeq ($(strip $(O_GITSTATUS)),1)
	patch --reverse --strip=1 --input=$(GITSTATUS)/mainline.diff
endif

skip: ;

.PHONY: all install uninstall strip static dist sign upload-local clean

=== debian/changelog ===
nnn (5.1-1) unstable; urgency=medium

  * Import new upstrem version
  * d/control:
    - Bump Standards-Version to 4.7.2
  * d/copyright:
    - Update d/copyright year
  * d/watch:
    - Remove the option filenamemangle
  * d/rules:
    - Fix tbl preprocessor failed

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 15 Aug 2025 21:53:52 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkgconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:

override_dh_missing:
	dh_missing --fail-missing

override_dh_installman:
	tbl nnn.1 > debian/nnn.1.tmp
	mv debian/nnn.1.tmp nnn.1
	dh_installman

=== debian/watch ===
version=4
opts=s/.+\/v?(\d\S+)\.tar\.gz/nnn-$1\.tar\.gz/ \
   https://github.com/jarun/nnn/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
